diff --git a/src/Adaptor3d/Adaptor3d_TopolTool.cxx b/src/Adaptor3d/Adaptor3d_TopolTool.cxx
index c22fc52..3795a7e 100644
--- a/src/Adaptor3d/Adaptor3d_TopolTool.cxx
+++ b/src/Adaptor3d/Adaptor3d_TopolTool.cxx
@@ -275,23 +275,39 @@ void Adaptor3d_TopolTool::NextVertex ()
   idVtx++;
 }
 
-
-TopAbs_State Adaptor3d_TopolTool::Classify(const gp_Pnt2d& P,
-					 const Standard_Real Tol,
-					 const Standard_Boolean )
-//					 const Standard_Boolean RecadreOnPeriodic)
+//=======================================================================
+//function : Classify
+//purpose  : 
+//=======================================================================
+TopAbs_State Adaptor3d_TopolTool::Classify(const gp_Pnt2d& theP,
+                                           const Standard_Real theTol3D,
+                                           const Standard_Boolean /*theIsAdjustReq*/)
 {
+  const Standard_Real aTolU = myS->UResolution(theTol3D),
+                      aTolV = myS->VResolution(theTol3D);
+  return Classify(theP, aTolU, aTolV);
+}
 
-  Standard_Real U = P.X();
-  Standard_Real V = P.Y();
+
+//=======================================================================
+//function : Classify
+//purpose  : 
+//=======================================================================
+TopAbs_State Adaptor3d_TopolTool::Classify(const gp_Pnt2d& theP,
+                                           const Standard_Real theTolU,
+                                           const Standard_Real theTolV)
+{
+  const Standard_Real aU = theP.X(), aV = theP.Y();
 
   if (nbRestr == 4) {
-    if ((U < Uinf - Tol) || (U > Usup + Tol) ||
-      (V < Vinf - Tol) || (V > Vsup + Tol)) {
+    if (((Uinf-aU) > theTolU) || ((aU-Usup) > theTolU) ||
+        ((Vinf-aV) > theTolV) || ((aV-Vsup) > theTolV))
+    {
         return TopAbs_OUT;
     }
-    if ((Abs(U - Uinf) <= Tol) || (Abs(U - Usup) <= Tol) ||
-      (Abs(V - Vinf) <= Tol) || (Abs(V - Vsup) <= Tol)) {
+    
+    if((Abs(aU - Uinf) <= theTolU) || (Abs(aU - Usup) <= theTolU) ||
+       (Abs(aV - Vinf) <= theTolV) || (Abs(aV - Vsup) <= theTolV)) {
         return TopAbs_ON;
     }
     return TopAbs_IN;
@@ -308,43 +324,43 @@ TopAbs_State Adaptor3d_TopolTool::Classify(const gp_Pnt2d& P,
     }
     else if (Precision::IsNegativeInfinite(Uinf)) {
       surumin = Standard_False;
-      if (U >= Usup+Tol) {
+      if ((aU-Usup) >= theTolU) {
 	      dansu = Standard_False;
 	      surumax = Standard_False;
       }
       else {
 	      dansu = Standard_True;
 	      surumax = Standard_False;
-	      if (Abs(U-Usup)<=Tol) {
+              if (Abs(aU - Usup) <= theTolU) {
 	        surumax = Standard_True;
 	      }
       }
     }
     else if (Precision::IsPositiveInfinite(Usup)) {
       surumax = Standard_False;
-      if (U < Uinf-Tol) {
+      if (theTolU < Uinf - aU) {
         dansu = Standard_False;
         surumin = Standard_False;
       }
       else {
         dansu = Standard_True;
         surumin = Standard_False;
-        if (Abs(U-Uinf)<=Tol) {
+        if (Abs(aU - Uinf) <= theTolU) {
           surumin = Standard_True;
         }
       }
     }
     else {
-      if ((U < Uinf - Tol) || (U > Usup + Tol)) {
+      if (((Uinf - aU) > theTolU) || ((aU - Usup) > theTolU)) {
         surumin = surumax = dansu = Standard_False;
       }
       else {
         dansu = Standard_True;
         surumin = surumax = Standard_False;
-        if (Abs(U-Uinf)<=Tol) {
+        if (Abs(aU - Uinf) <= theTolU) {
           surumin = Standard_True;
         }
-        else if (Abs(U-Usup)<=Tol) {
+        else if (Abs(aU - Usup) <= theTolU) {
           surumax = Standard_True;
         }
       }
@@ -357,43 +373,43 @@ TopAbs_State Adaptor3d_TopolTool::Classify(const gp_Pnt2d& P,
     }
     else if (Precision::IsNegativeInfinite(Vinf)) {
       survmin = Standard_False;
-      if (V > Vsup+Tol) {
+      if ((aV - Vsup) > theTolV) {
         dansv = Standard_False;
         survmax = Standard_False;
       }
       else {
         dansv = Standard_True;
         survmax = Standard_False;
-        if (Abs(V-Vsup)<=Tol) {
+        if (Abs(aV - Vsup) <= theTolV) {
           survmax = Standard_True;
         }
       }
     }
     else if (Precision::IsPositiveInfinite(Vsup)) {
       survmax = Standard_False;
-      if (V < Vinf-Tol) {
+      if (theTolV < (Vinf - aV)) {
         dansv = Standard_False;
         survmin = Standard_False;
       }
       else {
         dansv = Standard_True;
         survmin = Standard_False;
-        if (Abs(V-Vinf)<=Tol) {
+        if (Abs(aV - Vinf) <= theTolV) {
           survmin = Standard_True;
         }
       }
     }
     else {
-      if ((V < Vinf - Tol) || (V > Vsup + Tol)) {
+      if ((theTolV < (Vinf - aV)) || ((aV - Vsup) > theTolV)) {
         survmin = survmax = dansv = Standard_False;
       }
       else {
         dansv = Standard_True;
         survmin = survmax = Standard_False;
-        if (Abs(V-Vinf)<=Tol) {
+        if (Abs(aV - Vinf) <= theTolV) {
           survmin = Standard_True;
         }
-        else if (Abs(V-Vsup)<=Tol) {
+        else if (Abs(aV - Vsup) <= theTolV) {
           survmax = Standard_True;
         }
       }
@@ -409,139 +425,11 @@ TopAbs_State Adaptor3d_TopolTool::Classify(const gp_Pnt2d& P,
   }
 }
 
-
-
-Standard_Boolean  Adaptor3d_TopolTool::IsThePointOn(const gp_Pnt2d& P,
-					     const Standard_Real Tol,
-					     const Standard_Boolean )
-//					     const Standard_Boolean RecadreOnPeriodic)
+Standard_Boolean Adaptor3d_TopolTool::IsThePointOn(const gp_Pnt2d& theP,
+                                                   const Standard_Real theTol3D,
+                                                   const Standard_Boolean theIsAdjustReq)
 {
-
-  Standard_Real U = P.X();
-  Standard_Real V = P.Y();
-
-  if (nbRestr == 4) {
-    if ((U < Uinf - Tol) || (U > Usup + Tol) ||
-	(V < Vinf - Tol) || (V > Vsup + Tol)) {
-      return(Standard_False);
-    }
-    if ((Abs(U - Uinf) <= Tol) || (Abs(U - Usup) <= Tol) ||
-	(Abs(V - Vinf) <= Tol) || (Abs(V - Vsup) <= Tol)) {
-      return(Standard_True);
-    }
-    return(Standard_False);
-  }
-  else if (nbRestr == 0) {
-    return(Standard_False);
-  }
-  else {
-    Standard_Boolean dansu,dansv,surumin,surumax,survmin,survmax;
-    if (Precision::IsNegativeInfinite(Uinf) && 
-	Precision::IsPositiveInfinite(Usup)) {
-      dansu = Standard_True;
-      surumin = surumax = Standard_False;
-    }
-    else if (Precision::IsNegativeInfinite(Uinf)) {
-      surumin = Standard_False;
-      if (U >= Usup+Tol) {
-	dansu = Standard_False;
-	surumax = Standard_False;
-      }
-      else {
-	dansu = Standard_True;
-	surumax = Standard_False;
-	if (Abs(U-Usup)<=Tol) {
-	  surumax = Standard_True;
-	}
-      }
-    }
-    else if (Precision::IsPositiveInfinite(Usup)) {
-      surumax = Standard_False;
-      if (U < Uinf-Tol) {
-	dansu = Standard_False;
-	surumin = Standard_False;
-      }
-      else {
-	dansu = Standard_True;
-	surumin = Standard_False;
-	if (Abs(U-Uinf)<=Tol) {
-	  surumin = Standard_True;
-	}
-      }
-    }
-    else {
-      if ((U < Uinf - Tol) || (U > Usup + Tol)) {
-	surumin = surumax = dansu = Standard_False;
-      }
-      else {
-	dansu = Standard_True;
-	surumin = surumax = Standard_False;
-	if (Abs(U-Uinf)<=Tol) {
-	  surumin = Standard_True;
-	}
-	else if (Abs(U-Usup)<=Tol) {
-	  surumax = Standard_True;
-	}
-      }
-    }
-
-    if (Precision::IsNegativeInfinite(Vinf) &&
-	Precision::IsPositiveInfinite(Vsup)) {
-      dansv = Standard_True;
-      survmin = survmax = Standard_False;
-    }
-    else if (Precision::IsNegativeInfinite(Vinf)) {
-      survmin = Standard_False;
-      if (V > Vsup+Tol) {
-	dansv = Standard_False;
-	survmax = Standard_False;
-      }
-      else {
-	dansv = Standard_True;
-	survmax = Standard_False;
-	if (Abs(V-Vsup)<=Tol) {
-	  survmax = Standard_True;
-	}
-      }
-    }
-    else if (Precision::IsPositiveInfinite(Vsup)) {
-      survmax = Standard_False;
-      if (V < Vinf-Tol) {
-	dansv = Standard_False;
-	survmin = Standard_False;
-      }
-      else {
-	dansv = Standard_True;
-	survmin = Standard_False;
-	if (Abs(V-Vinf)<=Tol) {
-	  survmin = Standard_True;
-	}
-      }
-    }
-    else {
-      if ((V < Vinf - Tol) || (V > Vsup + Tol)) {
-	survmin = survmax = dansv = Standard_False;
-      }
-      else {
-	dansv = Standard_True;
-	survmin = survmax = Standard_False;
-	if (Abs(V-Vinf)<=Tol) {
-	  survmin = Standard_True;
-	}
-	else if (Abs(V-Vsup)<=Tol) {
-	  survmax = Standard_True;
-	}
-      }
-    }
-
-    if (!dansu || !dansv) {
-      return(Standard_False);
-    }
-    if (surumin || survmin || surumax || survmax) {
-      return(Standard_True);
-    }
-    return(Standard_False);;
-  }
+  return (Classify(theP, theTol3D, theIsAdjustReq) == TopAbs_ON);
 }
 
 
diff --git a/src/Adaptor3d/Adaptor3d_TopolTool.hxx b/src/Adaptor3d/Adaptor3d_TopolTool.hxx
index d2bfa34..6eb8525 100644
--- a/src/Adaptor3d/Adaptor3d_TopolTool.hxx
+++ b/src/Adaptor3d/Adaptor3d_TopolTool.hxx
@@ -40,7 +40,7 @@ DEFINE_STANDARD_HANDLE(Adaptor3d_TopolTool, Standard_Transient)
 //! from Adaptor3d.
 //! All methods and fields may be redefined when
 //! inheriting from this class.
-//! This class is used to instantiate algorithmes
+//! This class is used to instantiate algorithms
 //! as Intersection, outlines,...
 class Adaptor3d_TopolTool : public Standard_Transient
 {
@@ -74,9 +74,27 @@ public:
   
   Standard_EXPORT virtual void NextVertex();
   
-  Standard_EXPORT virtual TopAbs_State Classify (const gp_Pnt2d& P, const Standard_Real Tol, const Standard_Boolean ReacdreOnPeriodic = Standard_True);
-  
-  Standard_EXPORT virtual Standard_Boolean IsThePointOn (const gp_Pnt2d& P, const Standard_Real Tol, const Standard_Boolean ReacdreOnPeriodic = Standard_True);
+  //! Classifies theP relatively to the domain of myS.
+  //! theTol3D is the 3D-tolerance. Respective 2D-tolerance
+  //! is recomputed inside this method.
+  //! The parameter ReacdreOnPeriodic is not used in
+  //! this method (is kept for compatibility with
+  //! inherited classes).
+  Standard_EXPORT virtual 
+        TopAbs_State Classify(const gp_Pnt2d& theP,
+                              const Standard_Real theTol3D,
+                              const Standard_Boolean ReacdreOnPeriodic = Standard_True);
+
+  //! Returns TRUE if theP is on the boundary of the domain of myS.
+  //! theTol3D is the 3D-tolerance. Respective 2D-tolerance
+  //! is recomputed inside this method.
+  //! The parameter ReacdreOnPeriodic is not used in
+  //! this method (is kept for compatibility with
+  //! inherited classes).
+  Standard_EXPORT virtual
+        Standard_Boolean IsThePointOn(const gp_Pnt2d& theP,
+                                      const Standard_Real theTol3D,
+                                      const Standard_Boolean ReacdreOnPeriodic = Standard_True);
   
   //! If the function returns the orientation of the arc.
   //! If the orientation is FORWARD or REVERSED, the arc is
@@ -158,6 +176,12 @@ public:
 
 protected:
 
+  //! Classifies theP relatively to the domain of myS.
+  //! theTolU and theTolV are the 2D-tolerances.
+  Standard_EXPORT
+        TopAbs_State Classify(const gp_Pnt2d& theP,
+                              const Standard_Real theTolU,
+                              const Standard_Real theTolV);
 
   Handle(Adaptor3d_HSurface) myS;
   Standard_Integer myNbSamplesU;
diff --git a/src/BOPAlgo/BOPAlgo_BuilderFace.cxx b/src/BOPAlgo/BOPAlgo_BuilderFace.cxx
index 2caa3ff..1066774 100644
--- a/src/BOPAlgo/BOPAlgo_BuilderFace.cxx
+++ b/src/BOPAlgo/BOPAlgo_BuilderFace.cxx
@@ -36,7 +36,7 @@
 #include <gp_Pnt2d.hxx>
 #include <gp_Vec.hxx>
 #include <IntTools_Context.hxx>
-#include <IntTools_FClass2d.hxx>
+#include <BRepTopAdaptor_FClass2d.hxx>
 #include <NCollection_DataMap.hxx>
 #include <NCollection_UBTreeFiller.hxx>
 #include <TColStd_MapIntegerHasher.hxx>
@@ -423,7 +423,7 @@ void BOPAlgo_BuilderFace::PerformAreas()
     if (!bIsGrowth)
     {
       // Fast check did not give the result, run classification
-      IntTools_FClass2d& aClsf = myContext->FClass2d(aFace);
+      BRepTopAdaptor_FClass2d& aClsf = myContext->FClass2d(aFace);
       bIsGrowth = !aClsf.IsHole();
     }
 
@@ -721,7 +721,7 @@ Standard_Boolean IsInside(const TopoDS_Shape& theWire,
 
   // Get classification tool from the context
   const TopoDS_Face& aF = TopoDS::Face(theF);
-  IntTools_FClass2d& aClassifier = theContext->FClass2d(aF);
+  BRepTopAdaptor_FClass2d& aClassifier = theContext->FClass2d(aF);
 
   Standard_Boolean isInside = Standard_False;
 
diff --git a/src/BOPAlgo/BOPAlgo_PaveFiller_3.cxx b/src/BOPAlgo/BOPAlgo_PaveFiller_3.cxx
index cd04b75..82ca9b2 100644
--- a/src/BOPAlgo/BOPAlgo_PaveFiller_3.cxx
+++ b/src/BOPAlgo/BOPAlgo_PaveFiller_3.cxx
@@ -313,7 +313,7 @@ void BOPAlgo_PaveFiller::PerformEE()
           }
           //
           Standard_Boolean bIsOnPave[4], bFlag;
-          Standard_Integer nV[4], j;
+          Standard_Integer nV[4];
           Standard_Real aT1, aT2, aTol;
           TopoDS_Vertex aVnew;
           IntTools_Range aCR1, aCR2;
@@ -326,7 +326,7 @@ void BOPAlgo_PaveFiller::PerformEE()
           //decide to keep the pave or not
           bIsOnPave[0] = IntTools_Tools::IsOnPave1(aT1, aR11, aTol) ||
             IntTools_Tools::IsOnPave1(aR11.First(), aCR1, aTol);
-          bIsOnPave[1] = IntTools_Tools::IsOnPave1(aT1, aR12, aTol) || 
+          bIsOnPave[1] = IntTools_Tools::IsOnPave1(aT1, aR12, aTol) ||
             IntTools_Tools::IsOnPave1(aR12.Last(), aCR1, aTol);
           bIsOnPave[2] = IntTools_Tools::IsOnPave1(aT2, aR21, aTol) ||
             IntTools_Tools::IsOnPave1(aR21.First(), aCR2, aTol);
@@ -336,19 +336,48 @@ void BOPAlgo_PaveFiller::PerformEE()
           aPB1->Indices(nV[0], nV[1]);
           aPB2->Indices(nV[2], nV[3]);
           //
-          if((bIsOnPave[0] && bIsOnPave[2]) || 
-             (bIsOnPave[0] && bIsOnPave[3]) ||
-             (bIsOnPave[1] && bIsOnPave[2]) || 
-             (bIsOnPave[1] && bIsOnPave[3])) {
-            continue;
+          BOPTools_AlgoTools::MakeNewVertex(aE1, aT1, aE2, aT2, aVnew);
+          const gp_Pnt aPnew = BRep_Tool::Pnt(aVnew);
+
+          {
+            Standard_Boolean isOnTwoPaves = Standard_False;
+            for (Standard_Integer aPaveI = 0; (!isOnTwoPaves) && (aPaveI < 2); aPaveI++)
+            {
+              for (Standard_Integer aPaveJ = 2; aPaveJ < 4; aPaveJ++)
+              {
+                if (bIsOnPave[aPaveI] && bIsOnPave[aPaveJ])
+                {
+                  if (nV[aPaveI] == nV[aPaveJ])
+                  {
+                    const TopoDS_Vertex& aV = TopoDS::Vertex(myDS->Shape(nV[aPaveI]));
+                    const gp_Pnt aP2(BRep_Tool::Pnt(aV));
+                    UpdateVertex(nV[aPaveI], aPnew.Distance(aP2));
+                  }
+
+                  isOnTwoPaves = Standard_True;
+                  break;
+                }
+              }
+            }
+
+            if (isOnTwoPaves)
+              continue;
           }
           //
           bFlag = Standard_False;
-          for (j = 0; j < 4; ++j) {
+          for (Standard_Integer j = 0; j < 4; ++j) {
             if (bIsOnPave[j]) {
               //add interf VE(nV[j], nE)
               Handle(BOPDS_PaveBlock)& aPB = (j < 2) ? aPB2 : aPB1;
               bFlag = ForceInterfVE(nV[j], aPB, aMEdges);
+
+              if(bFlag)
+              {
+                const TopoDS_Vertex& aV = TopoDS::Vertex(myDS->Shape(nV[j]));
+                const gp_Pnt aP2 = BRep_Tool::Pnt(aV);
+                UpdateVertex(nV[j], aPnew.Distance(aP2));
+              }
+
               break;
             }
           }
@@ -359,14 +388,15 @@ void BOPAlgo_PaveFiller::PerformEE()
             continue;
           }
           //
-          BOPTools_AlgoTools::MakeNewVertex(aE1, aT1, aE2, aT2, aVnew);
           Standard_Real aTolVnew = BRep_Tool::Tolerance(aVnew);
           if (bAnalytical) {
             // increase tolerance for Line/Line intersection, but do not update 
             // the vertex till its intersection with some other shape
             Standard_Real aTolMin = (BRepAdaptor_Curve(aE1).GetType() == GeomAbs_Line) ?
-              (aCR1.Last() - aCR1.First()) / 2. : (aCR2.Last() - aCR2.First()) / 2.;
-            if (aTolMin > aTolVnew) {
+                                Max(Abs(aCR1.Last() - aT1), Abs(aCR1.First() - aT1)) :
+                                Max(Abs(aCR2.Last() - aT2), Abs(aCR2.First() - aT2));
+            if (aTolMin > aTolVnew)
+            {
               aTolVnew = aTolMin;
             }
           }
@@ -375,10 +405,10 @@ void BOPAlgo_PaveFiller::PerformEE()
             Standard_Integer nVS[2], iFound;
             Standard_Real aTolVx, aD2, aDT2;
             TColStd_MapOfInteger aMV;
-            gp_Pnt aPnew, aPx;
+            gp_Pnt aPx;
             //
             iFound=0;
-            j=-1;
+            Standard_Integer j=-1;
             aMV.Add(nV[0]);
             aMV.Add(nV[1]);
             //
@@ -391,8 +421,6 @@ void BOPAlgo_PaveFiller::PerformEE()
               nVS[j]=nV[3];
             }
             //
-            aPnew=BRep_Tool::Pnt(aVnew);
-            //
             for (Standard_Integer k1=0; k1<=j; ++k1) {
               const TopoDS_Vertex& aVx= *(TopoDS_Vertex*)&(myDS->Shape(nVS[k1]));
               aTolVx=BRep_Tool::Tolerance(aVx);
@@ -461,20 +489,20 @@ void BOPAlgo_PaveFiller::PerformEE()
   //=========================================
   BOPAlgo_Tools::PerformCommonBlocks(aMPBLPB, aAllocator, myDS);
   PerformNewVertices(aMVCPB, aAllocator);
-  //
+    //
   if (aMEdges.Extent()) {
     Standard_Integer aNbV = aMVCPB.Extent();
-    for (i = 1; i <= aNbV; ++i) {
+    for (i=1; i<=aNbV; ++i) {
       Handle(BOPDS_PaveBlock) aPB1, aPB2;
-      const BOPDS_CoupleOfPaveBlocks& aCPB = aMVCPB.FindFromIndex(i);
-      aCPB.PaveBlocks(aPB1, aPB2);
+      const BOPDS_CoupleOfPaveBlocks& aCPB=aMVCPB.FindFromIndex(i);
+      aCPB.PaveBlocks(aPB1, aPB2); 
       //
       aMEdges.Remove(aPB1->OriginalEdge());
       aMEdges.Remove(aPB2->OriginalEdge());
     }
-    //
+  //
     SplitPaveBlocks(aMEdges, Standard_False);
-  }
+    }
   //
   //-----------------------------------------------------scope t
   aMPBLPB.Clear();
@@ -501,11 +529,11 @@ void BOPAlgo_PaveFiller::PerformNewVertices
   TreatNewVertices(theMVCPB, aImages);
   //
   // 2. Add new vertices to myDS and connect indices to CPB structure
-  BOPDS_VectorOfInterfEE& aEEs = myDS->InterfEE();
+  BOPDS_VectorOfInterfEE& aEEs=myDS->InterfEE();
   BOPDS_VectorOfInterfEF& aEFs = myDS->InterfEF();
   //
   Standard_Integer i, aNb = aImages.Extent();
-  for (i = 1; i <= aNb; ++i) {
+  for (i=1; i<=aNb; ++i) {
     const TopoDS_Vertex& aV = TopoDS::Vertex(aImages.FindKey(i));
     const TopTools_ListOfShape& aLVSD = aImages.FindFromIndex(i);
     //
@@ -514,15 +542,15 @@ void BOPAlgo_PaveFiller::PerformNewVertices
     aSI.SetShape(aV);
     Standard_Integer iV = myDS->Append(aSI);
     //
-    BOPDS_ShapeInfo& aSIDS = myDS->ChangeShapeInfo(iV);
-    Bnd_Box& aBox = aSIDS.ChangeBox();
+    BOPDS_ShapeInfo& aSIDS=myDS->ChangeShapeInfo(iV);
+    Bnd_Box& aBox=aSIDS.ChangeBox();
     aBox.Add(BRep_Tool::Pnt(aV));
     aBox.SetGap(BRep_Tool::Tolerance(aV) + aTolAdd);
     //
     TopTools_ListIteratorOfListOfShape aItLS(aLVSD);
     for (; aItLS.More(); aItLS.Next()) {
       const TopoDS_Shape& aVx = aItLS.Value();
-      BOPDS_CoupleOfPaveBlocks &aCPB = theMVCPB.ChangeFromKey(aVx);
+      BOPDS_CoupleOfPaveBlocks &aCPB=theMVCPB.ChangeFromKey(aVx);
       aCPB.SetIndex(iV);
       // update interference
       Standard_Integer iX = aCPB.IndexInterf();
@@ -533,24 +561,24 @@ void BOPAlgo_PaveFiller::PerformNewVertices
   //
   // 3. Map PaveBlock/ListOfVertices to add to this PaveBlock ->aMPBLI
   BOPDS_IndexedDataMapOfPaveBlockListOfInteger aMPBLI(100, theAllocator);
-  for (i = 1; i <= aNbV; ++i) {
-    const BOPDS_CoupleOfPaveBlocks& aCPB = theMVCPB.FindFromIndex(i);
+    for (i=1; i<=aNbV; ++i) {
+      const BOPDS_CoupleOfPaveBlocks& aCPB=theMVCPB.FindFromIndex(i);
     Standard_Integer iV = aCPB.Index();
     //
     Handle(BOPDS_PaveBlock) aPB[2];
-    aCPB.PaveBlocks(aPB[0], aPB[1]);
+      aCPB.PaveBlocks(aPB[0], aPB[1]);
     for (Standard_Integer j = 0; j < 2; ++j) {
       TColStd_ListOfInteger *pLI = aMPBLI.ChangeSeek(aPB[j]);
       if (!pLI) {
         pLI = &aMPBLI(aMPBLI.Add(aPB[j], TColStd_ListOfInteger(theAllocator)));
-      }
+        }
       pLI->Append(iV);
-      //
+  //
       if (aPB[0] == aPB[1]) {
         break;
-      }
     }
   }
+    }
   //
   // 4. Compute Extra Paves and split Pave blocks by the Extra paves
   IntersectVE(aMPBLI, Standard_False);
@@ -560,14 +588,14 @@ void BOPAlgo_PaveFiller::PerformNewVertices
 //purpose  : 
 //=======================================================================
 void BOPAlgo_PaveFiller::TreatNewVertices
-  (const BOPDS_IndexedDataMapOfShapeCoupleOfPaveBlocks& theMVCPB,
+(const BOPDS_IndexedDataMapOfShapeCoupleOfPaveBlocks& theMVCPB,
    TopTools_IndexedDataMapOfShapeListOfShape& myImages)
 {
   //
   // Prepare for intersection
   TopTools_IndexedDataMapOfShapeReal aVerts;
   Standard_Integer i, aNbV = theMVCPB.Extent();
-  for (i = 1; i <= aNbV; ++i) {
+  for (i=1; i<=aNbV; ++i) {
     const TopoDS_Shape& aV = theMVCPB.FindKey(i);
     Standard_Real aTol = theMVCPB.FindFromIndex(i).Tolerance();
     aVerts.Add(aV, aTol);
@@ -581,12 +609,12 @@ void BOPAlgo_PaveFiller::TreatNewVertices
   TopTools_ListOfListOfShape::Iterator aItC(aChains);
   for (; aItC.More(); aItC.Next()) {
     const TopTools_ListOfShape& aLVSD = aItC.Value();
-    //
+  //
     TopoDS_Vertex aVNew;
     BOPTools_AlgoTools::MakeVertex(aLVSD, aVNew);
     myImages.Add(aVNew, aLVSD);
-  }
-}
+    }
+          }
 //=======================================================================
 //function : FillShrunkData
 //purpose  : 
@@ -668,7 +696,7 @@ void BOPAlgo_PaveFiller::AnalyzeShrunkData(const Handle(BOPDS_PaveBlock)& thePB,
 //purpose  : 
 //=======================================================================
 Standard_Boolean BOPAlgo_PaveFiller::ForceInterfVE(const Standard_Integer nV,
-                                                   Handle(BOPDS_PaveBlock)& aPB,
+                                       Handle(BOPDS_PaveBlock)& aPB,
                                                    TColStd_MapOfInteger& theMEdges)
 {
   Standard_Integer nE, nVx, nVSD, iFlag;
diff --git a/src/BOPAlgo/BOPAlgo_PaveFiller_5.cxx b/src/BOPAlgo/BOPAlgo_PaveFiller_5.cxx
index 7aa22d1..4238902 100644
--- a/src/BOPAlgo/BOPAlgo_PaveFiller_5.cxx
+++ b/src/BOPAlgo/BOPAlgo_PaveFiller_5.cxx
@@ -357,29 +357,29 @@ void BOPAlgo_PaveFiller::PerformEF()
           for (j=0; j<2; ++j) {
             if (bIsOnPave[j]) {
               bV[j]=CheckFacePaves(nV[j], aMIFOn, aMIFIn);
-              if (bV[j]) {
-                const TopoDS_Vertex& aV=
-                  (*(TopoDS_Vertex *)(&myDS->Shape(nV[j])));
-                //
-                Standard_Real f, l, aTolVnew, aDistPP, aTolPC, aTolV;
-                //
-                const Handle(Geom_Curve)& aCur = BRep_Tool::Curve(aE, f, l);
-                //
-                gp_Pnt aP1 = BRep_Tool::Pnt(aV);
-                gp_Pnt aP2 = aCur->Value(aT);
-                //
-                aDistPP=aP1.Distance(aP2);
-                //
-                aTolPC=Precision::PConfusion();
-                aTolV=BRep_Tool::Tolerance(aV);
-                if (aDistPP > (aTolV+aTolPC)) {
-                  aTolVnew=Max(aTolE, aDistPP);
-                  UpdateVertex(nV[j], aTolVnew);
-                }
-              }
-              else {
+              if (!bV[j])
+              {
                 bIsOnPave[j] = ForceInterfVF(nV[j], nF);
               }
+
+              const TopoDS_Vertex& aV =
+                (*(TopoDS_Vertex *)(&myDS->Shape(nV[j])));
+              //
+              Standard_Real f, l, aTolVnew, aDistPP, aTolPC, aTolV;
+              //
+              const Handle(Geom_Curve)& aCur = BRep_Tool::Curve(aE, f, l);
+              //
+              gp_Pnt aP1 = BRep_Tool::Pnt(aV);
+              gp_Pnt aP2 = aCur->Value(aT);
+              //
+              aDistPP = aP1.Distance(aP2);
+              //
+              aTolPC = Precision::PConfusion();
+              aTolV = BRep_Tool::Tolerance(aV);
+              if (aDistPP > (aTolV + aTolPC)) {
+                aTolVnew = Max(aTolE, aDistPP);
+                UpdateVertex(nV[j], aTolVnew);
+              }
             }
           }
           //
diff --git a/src/BOPAlgo/BOPAlgo_PaveFiller_6.cxx b/src/BOPAlgo/BOPAlgo_PaveFiller_6.cxx
index 66fcea7..bc3a3a5 100644
--- a/src/BOPAlgo/BOPAlgo_PaveFiller_6.cxx
+++ b/src/BOPAlgo/BOPAlgo_PaveFiller_6.cxx
@@ -554,6 +554,10 @@ void BOPAlgo_PaveFiller::MakeBlocks()
         //
         // Make Edge
         BOPTools_AlgoTools::MakeEdge (aIC, aV1, aT1, aV2, aT2, aTolR3D, aES);
+
+        if (aES.IsNull())
+          continue;
+
         //
         // check for micro edge
         if (BOPTools_AlgoTools::IsMicroEdge(aES, myContext, Standard_False)) {
